using System;
using System.Net.Http;
using System.Threading.Tasks;
using EtherealEngine.Services;

namespace EtherealEngine.Inject;

internal static class InjectorTasks
{
	private static readonly HttpClient WebClient;

	public static event EventHandler<TaskEventArgs> DownloadCompleted;

	public static event EventHandler<TaskEventArgs> InstallationCompleted;

	public static event EventHandler<TaskEventArgs> UninstallCompleted;

	public static event EventHandler<TaskEventArgs> UpdateCompleted;

	public static event EventHandler BeginDownloading;

	public static event EventHandler BeginInstalling;

	public static event EventHandler BeginUninstalling;

	public static event EventHandler BeginUpdating;

	public static async Task ForceGTAVFocus()
	{
		for (int i = 0; i < 201; i++)
		{
			await Task.Delay(100);
			Gta.SwitchToGTA5();
		}
	}

	static InjectorTasks()
	{
		InjectorTasks.DownloadCompleted = delegate
		{
		};
		InjectorTasks.InstallationCompleted = delegate
		{
		};
		InjectorTasks.UninstallCompleted = delegate
		{
		};
		InjectorTasks.UpdateCompleted = delegate
		{
		};
		InjectorTasks.BeginDownloading = delegate
		{
		};
		InjectorTasks.BeginInstalling = delegate
		{
		};
		InjectorTasks.BeginUninstalling = delegate
		{
		};
		InjectorTasks.BeginUpdating = delegate
		{
		};
		WebClient = new HttpClient();
	}
}
