using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text.RegularExpressions;
using System.Windows;

namespace EtherealEngine.Services;

public class Logger
{
	public static List<string> GetLogStats(Window win)
	{
		Regex regex = new Regex("(?<=Crash from: ).*$");
		Regex regex2 = new Regex("(?<=Logged in as ).*(?= \\| Rockstar ID:)");
		Regex regex3 = new Regex("(\\w+)$");
		List<string> list = new List<string>();
		List<string> list2 = new List<string>();
		List<string> list3 = new List<string>();
		string item = "Unknown";
		string item2 = "000000000";
		try
		{
			FileStream stream = new FileStream("C:\\Ethereal\\Ethereal.log", FileMode.Open, FileAccess.Read, FileShare.ReadWrite);
			if (File.Exists("C:\\Ethereal\\Ethereal.log"))
			{
				using StreamReader streamReader = new StreamReader(stream);
				while (!streamReader.EndOfStream)
				{
					string text = streamReader.ReadLine();
					if (!string.IsNullOrEmpty(text))
					{
						if ((!list2.Contains(text) && text.Contains("[Info] Finished")) || text.Contains("[Info] Finsihed") || text.EndsWith("Finished") || text.Contains("[Info] Buffer crash terminates"))
						{
							list2.Add(text);
						}
						Match match = regex.Match(text);
						if (text.Contains("[Protection]") && !list.Contains(text) && match.Success)
						{
							list.Add(text);
						}
						if (text.Contains("[Player Joined]") && !list3.Contains(text))
						{
							list3.Add(text);
						}
						if (text.Contains("[Player Left]") && !list3.Contains(text))
						{
							list3.RemoveAt(0);
						}
						Match match2 = regex2.Match(text);
						if (text.Contains("Logged in as") && match2.Success)
						{
							item = match2.Captures.First().Value;
						}
						Match match3 = regex3.Match(text);
						if (text.Contains("Logged in as") && match2.Success)
						{
							item2 = match3.Captures.First().Value;
						}
						if (text.EndsWith("[Notify] Leaving a session."))
						{
							list3.Clear();
						}
					}
				}
			}
		}
		catch (Exception)
		{
		}
		return new List<string>
		{
			list.Count.ToString(),
			list2.Count.ToString(),
			list3.Count.ToString(),
			item,
			item2
		};
	}
}
